package com.lideeyunji.service.system.service;

import com.lideeyunji.tool.framework.common.pojo.PageResult;
import com.lideeyunji.service.system.controller.vo.dept.position.PositionPageReqVO;
import com.lideeyunji.service.system.controller.vo.dept.position.PositionSaveReqVO;
import com.lideeyunji.service.system.entity.PositionDO;
import org.springframework.lang.Nullable;

import java.util.Collection;
import java.util.List;

/**
 * 职位 Service 接口
 *
 * @author 金灯剑客
 */
public interface IPositionService {

    /**
     * 创建职位
     *
     * @param createReqVO 职位信息
     * @return 职位编号
     */
    Long createPosition(PositionSaveReqVO createReqVO);

    /**
     * 更新职位
     *
     * @param updateReqVO 职位信息
     */
    void updatePosition(PositionSaveReqVO updateReqVO);

    /**
     * 删除职位信息
     *
     * @param id 职位编号
     */
    void deletePosition(Long id);

    /**
     * 获得职位列表
     *
     * @param ids 职位编号数组
     * @return 部门列表
     */
    List<PositionDO> getPositionList(@Nullable Collection<Long> ids);
    List<PositionDO> getPositionList();

    /**
     * 获得符合条件的职位列表
     *
     * @param ids 职位编号数组。如果为空，不进行筛选
     * @param statuses 状态数组。如果为空，不进行筛选
     * @return 部门列表
     */
    List<PositionDO> getPositionList(@Nullable Collection<Long> ids,
                                     @Nullable Collection<Integer> statuses);

    /**
     * 获得职位分页列表
     *
     * @param reqVO 分页条件
     * @return 部门分页列表
     */
    PageResult<PositionDO> getPositionPage(PositionPageReqVO reqVO);

    /**
     * 获得职位信息
     *
     * @param id 职位编号
     * @return 职位信息
     */
    PositionDO getPosition(Long id);

    /**
     * 校验职位们是否有效。如下情况，视为无效：
     * 1. 职位编号不存在
     * 2. 职位被禁用
     *
     * @param ids 职位编号数组
     */
    void validatePositionList(Collection<Long> ids);

}
